cos/routes/web.php
<?php
use RealRashid\SweetAlert\Facades\Alert;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::resource('clientes', 'ClientesController');



Auth::routes();

Route::get('/', 'HomeController@index')->name('home');


//rutas de cliente

//Route::post('/clientes', 'ClientesController@store')->name('cliente.store');
Route::get('/cliente', 'ClientesController@index')->name('cliente');
Route::delete('/cliente/{idCliente}', 'ClientesController@destroy')->name('eliminar-cliente');

//Route::get('/cliente/{idCliente}/edit', 'ClientesController@edit')->name('editar-cliente')->middleware('auth');

Route::post('/cliente/{idCliente}/editar','ClientesController@update')->name('cliente.update');

Route::get('/cliente-agregar','ClientesController@create')->name('agregar-cliente')->middleware('auth');

Route::post('/clientes/agregar','ClientesController@store')->name('agregarCliente');

//rutas de departamentos
Route::get('/departamentos/{idCliente}', 'ClientesController@departamentoAjax');
Route:: get ("/MyAjax/{idCliente}", "ClientesController@MyAjax");

cos/app/Clientes.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;

class clientes extends Model
{
    protected $table="clientes";

    protected $primaryKey = "idCliente";
    protected $fillable = ['nombreCliente','apellidoCliente','telefonoCliente','usIdUsuario','id_Paises','id_Departamento','id_sexo'];
    
    public function sexo(){
        return $this->belongsTo(Sexo::class,'id_sexo');
    }
    public function user(){
        return $this->belongsTo(User::class,'usIdUsuario');
    }
    public function paises(){
        return $this->belongsTo(Paises::class,'id_Paises');
    }
    public function departamentos(){
        return $this->belongsTo(departamentos::class,'id_Departamento');
    }
    public function selectDepartamento($id_pais){
        $query=DB::select("SELECT idPaises, nombrePais FROM paises ORDER by nombrePais ASC");
        return $query;
    }
}

cos/app/Http/Controllers/ClientesController.php
<?php

namespace App\Http\Controllers;


//modelos
use App\Clientes;
use App\departamentos;
use App\Http\Requests\ClienteStoreRequest;
use App\Http\Requests\ClienteUpdateRequest;
use App\Paises;
use App\Sexo;
use App\User;
//
use Illuminate\Support\Facades\DB;
//request
use Illuminate\Http\Request;
use RealRashid\SweetAlert\Facades\Alert;
use Symfony\Component\Console\Input\Input;

class ClientesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {



        $clientes = clientes::orderBy('idCliente')->get();
        $clientes->each(function ($clientes) {
            $clientes->sexo;
            $clientes->user;
            $clientes->paises;
            $clientes->departamentos;
        });
        return view('Cliente.index', compact('clientes'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('Cliente.create');
    }
    public function crear()
    {
        return view('Cliente.create', compact('paises'));
        return view('Cliente.create', compact('users'));
    }
    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ClienteStoreRequest  $request)
    {
        //creacion de cliente

        Clientes::create($request->all());
        alert()->success('El cliente fue registrado con exito');
        return redirect()->route('cliente')->with('success', ' El cliente fue registrado');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Clientes  $clientes
     * @return \Illuminate\Http\Response
     */
    public function show(Clientes $clientes)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Clientes  $clientes
     * @return \Illuminate\Http\Response
     */

    public function edit($idCliente)
    {
        //ciente
        $clientes = Clientes::find($idCliente);
        //sexo
        $sex = Sexo::all();
        $id_Sexo = $clientes->id_Sexo;
        $tipoSexo = Sexo::find($id_Sexo);
        //pais
        $pais = Paises::all();
        $idPaises = $clientes->id_Paises;
        $nombrePais = Paises::find($idPaises);
        //departamento
        $departamentosDP = departamentos::where('id_Paises',  $idPaises)->get();
        $id_Departamento = $clientes->id_Departamento;
        $nombreDepartamento = departamentos::find($id_Departamento);

        //retorno de datos
        return view('Cliente.edit')
            //cliente
            ->with('clientes', $clientes)
            //sexo
            ->with('sexss', $sex)
            ->with('tiposSexo', $tipoSexo)
            //pais
            ->with('paisess', $pais)
            ->with('nombrePais', $nombrePais)
            ->with('idPaises', $idPaises)
            //departamento
            ->with('departamentosDP', $departamentosDP)
            ->with('nombreDepartamento', $nombreDepartamento)
            ->with('idDepartamento', $id_Departamento);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Clientes  $clientes
     * @return \Illuminate\Http\Response
     */
    public function update(ClienteUpdateRequest $request, $idCliente)
    {
        // $clienteD= request()->extends(['_token','_method']);
        $cliente = Clientes::find($idCliente)->update($request->all());
        alert()->success('Datos actualizados con éxito', 'Listo');
        return redirect('cliente')->with('status', 'Datos actualizados correctamente');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Clientes  $clientes
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        Clientes::destroy($id);
        return redirect('cliente');
    }
    public function getDepartamentos(Request $request)
    {
        if ($request->ajax()) {


            $departamentos = departamentos::where('id_Paises', $request->id_Paises)->get();

            foreach ($departamentos as $departamento) {


                $departamentosArray[$departamento->id_Departamento] = $departamento->nombre_departamento;
            }
            return response()->json($departamentosArray);
        }
    }
    public function departamentoAjax($idCliente)
    {
        $departamentos["departamento"] = departamentos::where('id_Paises', $idCliente)->get();
        return Response()->json($departamentos, 200);
    }
}

cos/resources/views/Cliente/create.blade.php
@extends('layouts.app')

@section('content')
@inject('paises', 'App\Services\Paise')
@inject('users', 'App\Services\Users')
@inject('sexo', 'App\Services\Sexos')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Registrar cliente</div>
                <div class="card-body">
                    <h1 class="text-center ">Registrate</h1>
                    <form action="{{ route('agregarCliente')}}" method="POST">
                        @csrf
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                {{ csrf_field()}}
                                {{ method_field('POST') }}
                                <label for="nombreCliente">Nombre</label>
                                <input type="text" class="form-control {{ $errors->has('nombreCliente') ? ' is-invalid' : '' }}" value="{{ old('nombreCliente') }}" id="nombreCliente" name="nombreCliente" >
                                @error('nombreCliente')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                            <div class="form-group col-md-6">
                                <label for="apellidoCliente">Apellido</label>
                                <input type="text" class="form-control {{ $errors->has('apellidoCliente') ? ' is-invalid' : '' }}" value="{{ old('apellidoCliente') }}" id="apellidoCliente" name="apellidoCliente" >
                                @error('apellidoCliente')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label for="id_sexo">Sexo</label>
                                    <select name="id_sexo" id="id_sexo" class="form-control {{ $errors->has('id_sexo') ? ' is-invalid' : '' }}" value="{{ old('sexo')}}">
                                        @foreach ($sexo ->get() as $index => $sex)
                                        <option value="{{ $index }}" {{ old('id_sexo') == $index ? 'selected' : '' }}>
                                            {{$sex}}
                                        </option>
                                        @endforeach
                                    </select>
                                    @error('id_sexo')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                            </div>
                            <div class="form-group col-md-6">
                                <label for="telefonoCliente">Teléfono</label>
                                <input type="number" class="form-control {{ $errors->has('telefonoCliente') ? ' is-invalid' : '' }}" id="telefonoCliente" name="telefonoCliente" value="{{ old('telefonoCliente') }}">
                                @error('telefonoCliente')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label for="Pais">País donde reside</label>
                                    <select name="id_Paises" id="Pais" class="form-control {{ $errors->has('id_Paises') ? ' is-invalid' : '' }}" value="{{ old('Pais') }}">
                                    @foreach ($paises ->get() as $index => $pais)
                                    <option value="{{ $index }}" {{ old('id_Paises') == $index ? 'selected' : '' }}>
                                        {{$pais}}
                                    </option>
                                    @endforeach
                                </select>
                                 @if ($errors->has('id_Paises'))
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $errors->first('id_Paises') }}</strong>
                                </span>
                                @endif
                            </div>
                            <div class="form-group col-md-6">
                                <label for="departamento">departamento</label>
                                <select id="departamento" data-old="{{ old('id_Departamento') }}" name="id_Departamento" class="form-control {{ $errors->has('id_Departamento') ? ' is-invalid' : '' }}"></select>
                                @error('id_Departamento')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-12">
                                <label for="usIdUsuario">Correo de usuario</label>
                                <select name="usIdUsuario" id="User" class="form-control {{ $errors->has('usIdUsuario') ? ' is-invalid' : '' }}">
                                    @foreach ($users ->get() as $index => $user)

                                    <option value="{{ $index }}" {{ old('usIdUsuario') == $index ? 'selected' : '' }}>
                                        {{$user}}
                                    </option>
                                    @endforeach
                                </select>
                                @error('usIdUsuario')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>
                        <button type="submit" class="btn btn-primary btn-lg btn-block">Registrar</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@include('sweetalert::alert' )
@endsection

cos/resources/views/Cliente/edit.blade.php
@extends('layouts.app')

@section('content')
@inject('paises', 'App\Services\Paise')
@inject('users', 'App\Services\Users')
@inject('sexo', 'App\Services\Sexos')

<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header"> Datos de cliente</div>
                <div class="card-body">
                <form method="POST" action="{{route('clientes.update',$clientes)}}">
                       
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                {{ csrf_field()}}
                                {{ method_field('PATCH') }}
                                <label for="nombreCliente">Nombre</label>
                                <input type="text" class="form-control {{ $errors->has('nombreCliente') ? ' is-invalid' : '' }}" value="{{ $clientes->nombreCliente }}" id="nombreCliente" name="nombreCliente" >
                                @error('nombreCliente')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror

                            </div>
                            <div class="form-group col-md-6">
                                <label for="apellidoCliente">Apellido</label>
                                <input type="text" class="form-control {{ $errors->has('apellidoCliente') ? ' is-invalid' : '' }}" value="{{ $clientes->apellidoCliente }}" id="apellidoCliente" name="apellidoCliente" >
                                @error('apellidoCliente')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label for="sexoCliente">Sexo</label>
                                <select name="id_sexo" id="id_sexo" class="form-control {{ $errors->has('id_sexo') ? ' is-invalid' : '' }}" value="{{ old('sexo')}}">
                                        @foreach ($sexo ->get() as $index => $sex)
                                        <option value="{{ $index }}" {{ old('id_sexo') == $index ? 'selected' : '' }}>
                                            {{$sex}}
                                        </option>
                                        @endforeach
                                    </select>
                                    @error('id_sexo')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            <div class="form-group col-md-6">
                                <label for="telefonoCliente">Teléfono</label>
                                <input type="number" class="form-control {{ $errors->has('telefonoCliente') ? ' is-invalid' : '' }}" id="telefonoCliente" name="telefonoCliente" value="{{ $clientes->telefonoCliente }}">
                                @error('telefonoCliente')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label for="Pais">País donde reside</label>
                                    <select name="id_Paises" id="Pais" class="form-control {{ $errors->has('id_Paises') ? ' is-invalid' : '' }}" value="{{ old('Pais') }}">
                                    <option value="0">Seleccione...</option>
                                    @foreach ($paisess as $index => $pais)
                                    <option value="{{ $pais->idPaises }}" {{ $pais->idPaises == $idPaises ? 'selected' : '' }}>
                                        {{$pais->nombrePais}}
                                    </option>
                                    @endforeach

                                </select>
                                @if ($errors->has('id_Paises'))
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $errors->first('id_Paises') }}</strong>
                                </span>
                                @endif

                            </div>
                            <div class="form-group col-md-6">
                                <label for="departamento">Departamento</label>
                                    <select id="departamento" data-old="{{ old('id_Departamento') }}" name="id_Departamento" class="form-control {{ $errors->has('id_Departamento') ? ' is-invalid' : '' }}">
                                    <option value="0">Seleccione...</option>
                                    @foreach ($departamentosDP as $index => $departamento)
                                    <option value="{{ $departamento->id_Departamento }}" {{ $departamento->id_Departamento == $idDepartamento ? 'selected' : '' }}>
                                        {{$departamento->nombre_departamento}}
                                    </option>
                                    @endforeach
                                </select>
                                @error('id_Departamento')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-12">
                                <label for="usIdUsuario">Correo de usuario</label>
                                    <select name="usIdUsuario" id="User" class="form-control {{ $errors->has('usIdUsuario') ? ' is-invalid' : '' }}">
                                    @foreach ($users ->get() as $index => $user)
                                    <option value="{{ $index }}" {{ old('usIdUsuario') == $index ? 'selected' : '' }}>
                                        {{$user}}
                                    </option>
                                    @endforeach
                                </select>
                                @error('usIdUsuario')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>
                        <button type="submit" class=" btn btn-info btn-lg btn-block">editar</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection

cos/resources/views/Cliente/form.blade.php
@extends('layouts.app')

@section('content')
@inject('paises', 'App\Services\Paise')
@inject('users', 'App\Services\Users')
@inject('sexo', 'App\Services\Sexos')

<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Registrar cliente</div>

                <div class="card-body">


                    <h1 class="text-center ">Registrate</h1>
                    <form action="{{ route('cliente.store')}}" method="POST">
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                {{ csrf_field()}}
                                <label for="nombreCliente">Nombre</label>
                                <input type="text" class="form-control" id="nombreCliente" name="nombreCliente">
                            </div>
                            <div class="form-group col-md-6">
                                <label for="apellidoCliente">Apellido</label>
                                <input type="text" class="form-control" id="apellidoCliente" name="apellidoCliente">
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label for="sexoCliente">Sexo</label>
                                    <select name="id_sexo" id="id_sexo" class="form-control">
                                        @foreach ($sexo ->get() as $index => $sex)
                                        <option value="{{ $index }}" {{ old('id_sexo') == $index ? 'selected' : '' }}>
                                            {{$sex}}
                                        </option>
                                        @endforeach
    
                                    </select>
                                    @if ($errors->has('id_sexo'))
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $errors->first('id_sexo') }}</strong>
                                    </span>
                                    @endif
                                </div>
                            
                            <div class="form-group col-md-6">
                                <label for="telefonoCliente">Teléfono</label>
                                <input type="number" class="form-control" id="telefonoCliente" name="telefonoCliente">
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label for="Pais">País donde reside</label>
                                <select name="id_Paises" id="Pais" class="form-control">
                                    @foreach ($paises ->get() as $index => $pais)

                                    <option value="{{ $index }}" {{ old('id_Paises') == $index ? 'selected' : '' }}>
                                        {{$pais}}
                                    </option>
                                    @endforeach

                                </select>
                                @if ($errors->has('id_Paises'))
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $errors->first('id_Paises') }}</strong>
                                </span>
                                @endif
                            </div>
                            <div class="form-group col-md-6">
                                <label for="departamento">departamento</label>


                                <select id="departamento" data-old="{{ old('id_Departamento') }}" name="id_Departamento" class="form-control{{ $errors->has('id_Departamento') ? ' is-invalid' : '' }}"></select>
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-12">
                                <label for="usIdUsuario">Usuario</label>
                                <select name="usIdUsuario" id="User" class="form-control">
                                    @foreach ($users ->get() as $index => $user)

                                    <option value="{{ $index }}" {{ old('usIdUsuario') == $index ? 'selected' : '' }}>
                                        {{$user}}
                                    </option>
                                    @endforeach

                                </select>


                            </div>
                        </div>


                        <button type="submit" class="btn btn-primary btn-lg btn-block">Registrar</button>
                    </form>


                </div>
            </div>
        </div>
    </div>
</div>
@endsection

cos/resources/views/Cliente/index.blade.php
@extends('layouts.app')

@section('content')

@inject('users', 'App\Services\Users')

<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            <div class="card ">
                <div class="card-header">
                    cliente
                </div>
                @if(session('flash'))
                <br>
                <div class="alert alert-success" role="alert">
                    <strong>Aviso:</strong>{{session('flash')}}
                    <button type="button" class="close" data-dismiss="alert" alert-lable="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                @endif
                @if(session('success_message'))
                <br>
                <div class="alert alert-success">
                    {{ session('success_message')}}

                </div>
                @endif
                <ul class=" list-group list-group-flush">
                    <li class="list-group-item"> 
                        <a href="{{ route('agregar-cliente') }}">agregar</a>
                    </li>
                </ul>
            
                <div class="card-body">
                    <div class="table-responsive">
                        <table id="table_id" class="table table-striped" >
                            <thead class="thead-light">
                                <th>Nombre del cliente</th>
                                <th>apellido del cliente</th>
                                <th>sexo del cliente</th>
                                <th>Teléfono del cliente</th>
                                <th>Corre</th>
                                <th>Pais</th>
                                <th>Departamento</th>
                                <th>Acciones</th>
                            </thead>
                            <tbody>
                                @foreach ($clientes as $cliente)
                                <tr>
                                    <td>{{ $cliente->nombreCliente }}</td>
                                    <td>{{ $cliente->apellidoCliente }}</td>
                                    <td>{{ $cliente->sexo->nombre_sexo }}</td>
                                    <td>{{ $cliente->telefonoCliente}}</td>
                                    <td>{{ $cliente->user->email }}</td>
                                    <td>{{ $cliente->paises->nombrePais }}</td>
                                    <td>{{ $cliente->departamentos->nombre_departamento}}</td>
                                    <td>
                                        <a href="{{ route('clientes.edit',$cliente->idCliente) }}" class="btn-accion-tabla tooltipsC" title="Editar este registro">
                                            <i class="fas fa-pencil-alt"></i>
                                        </a>
                                        <form  action="{{ route('eliminar-cliente',['idCliente' =>$cliente->idCliente]) }}"class="d-inline form-eliminar" method="POST" >
                                            @csrf @method("delete")
                                            <button type="submit" class="btn-accion-tabla" title="eliminar este registro" >
                                                <i class="fa fa-fw fa-trash text-danger" value="eliminar"></i>
                                            </button>
                                        </form>
                                    </td>
                                </tr>
                                @endforeach
                            </tbody>

                        </table>
                    </div>


                </div>
            </div>
        </div>
    </div>
</div>
@include('sweetalert::alert')
@endsection
@section('script')
<script>
      
  $(document).ready(function () {
    $('#table_id').DataTable({
      "language": {
        "url": "//cdn.datatables.net/plug-ins/1.10.15/i18n/Spanish.json"
      }
    });
  });
</script>
    
@endsection